
/******************************************************************************
* Filename     : config.h                                                     *
* Program      : loader.                                                      *
* Copyright    : Copyright (C) 2001, Young-Su, Ahn.                           *
* Author       : Young-Su, Ahn <nurie@dreamwiz.com>                           *
* Description  : Set environment of loader.                                   *
* Created at   : Wed Mar 13 2001.                                             *
* Based on     : blob-1.0.8-pre2 (http://www.lart.tudelft.nl)                 *
* Modified by  :                                                              *
* Modified at  :                                                              *
******************************************************************************/
/* This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _CONFIG_H_4718034674012374874802
#define _CONFIG_H_4718034674012374874802


///// Serial //////////////////////////////////////////////////////////////////
//#define USE_SERIAL1						// Use Serial Port 1.
#define USE_SERIAL3						// Use Serial Port 3.

#define SERIAL_SPEED			1			// Serial Speed (SCR).
#define SERIAL_DOWNLOAD_SPEED		1
// SCR   :  Speed
// 191   :   1200
//  23   :   9600
//  11   :  19200
//   5   :  38400
//   3   :  57600
//   1   : 115200

// Data Bit.
// ̰ defineǾ ־ Ʒ Default .
#define SERIAL_CONFIG

#ifdef SERIAL_CONFIG
//#define SERIAL_DATA_BIT			UTCR0_7BitData			// Data Bit 7.
#define SERIAL_DATA_BIT			UTCR0_8BitData			// Data Bit 8.

// Stop Bit.
#define SERIAL_STOP_BIT			UTCR0_1StpBit			// Stop Bit 1.
//#define SERIAL_STOP_BIT			UTCR0_2StpBit			// Stop Bit 2.

// Parity Bit.
#define SERIAL_PARITY_ENABLE	0						// Parity Bit  .
//#define SERIAL_PARITY_ENABLE	UTCR0_PE				// parity Bit .

#define SERIAL_PARITY			0						// Parity Bit  .
//#define SERIAL_PARITY			UTCR0_OddPar			// Odd Parity Bit .
//#define SERIAL_PARITY			UTCR0_EvenPar			// Even Parity Bit .
#endif


// USE_SERIAL_UUCODEC defineǾ , Bootloader download     ,  ׷
//    , UUEncode() UUDecode()  Compile ʴ´.
//#define NOT_USE_SERIAL_UUCODEC
#define USE_SERIAL_UUCODEC



///// Static Memory ///////////////////////////////////////////////////////////
// FLASHBIT : Flash ϳ ϴ data pin bit .
// FLASHNUM  : Flash ϴ Chip Select   Flash .
// FLASHSIZE : Flash ϴ Chip Select   Flash  ũ.
// one of 16 bit flash memory.
#define FLASHBIT				16
#define FLASHNUM				1
#define FLASHSIZE				(0x01000000)	// 16 MB.
// two of 16 bit flash memory.
//#define FLASHBIT				16
//#define FLASHNUM				2
//#define FLASHSIZE				(0x02000000)	// 32 MB.

// Chip Select Pin number for flash.
#define USE_CS0_FLASH							// CS0 Flash .
//#define USE_CS1_FLASH							// bootrom   ׽Ʈ ġ ʾ.

// flash memory ġ.
#if defined USE_CS0_FLASH
#define SRAM_BASE_ADDR			(0x00000000)
#elif defined USE_CS1_FLASH
#define SRAM_BASE_ADDR			(0x08000000)
#endif
#define SRAM_SIZE				FLASHSIZE		// 16 MB.
#define SRAM_BLOCK_SIZE			(0x00020000)


///// Dynamic Memory //////////////////////////////////////////////////////////
#define DRAM_BASE_ADDR			(0xc0000000)
#define DRAM_SIZE				(0x02000000)


///// Package Information /////////////////////////////////////////////////////
#define PACKAGE					"tbloader"		    // Name of package.
#define VERSION					"E2G CS8900 Test"	// Version number of package.


///// BootLoader //////////////////////////////////////////////////////////////
// TINY_LOADER defineǾ  ּ    loader .
#define FULL_LOADER
//#define TINY_LOADER
//#define MY_LOADER

// Position of BOOT LOADER.
#define LOADER_SRAM_BASE	(0x00000000)	// Static memory ġ.
#define LOADER_SRAM_MAX_SIZE	(0x00020000)	// loader  ũ Flash Block ũ .
#define LOADER_DRAM_MAX_SIZE	(0x00020000)	// 2Mbytes. compile loader 64kbyte ̻ 
//#define LOADER_DRAM_MAX_SIZE	(0x00100000)	// 2Mbytes. compile loader 64kbyte ̻ 
					// ld-script  ٲپ ־ մϴ.
#define LOADER_DRAM_BASE		(DRAM_BASE_ADDR+DRAM_SIZE-LOADER_DRAM_MAX_SIZE)
#define STACK_POINT				(DRAM_BASE_ADDR+DRAM_SIZE-LOADER_DRAM_MAX_SIZE-4)

// Position of kernel.
#ifdef  USE_CS0_FLASH
#define KERNEL_SRAM_BASE		(SRAM_BASE_ADDR+LOADER_SRAM_MAX_SIZE)
#else
#define KERNEL_SRAM_BASE		(SRAM_BASE_ADDR)
#endif
#define KERNEL_DRAM_BASE		(0xc0008000)
#define KERNEL_MAX_SIZE			(0x000c0000)
#define NUM_KERNEL_BLOCKS		(KERNEL_MAX_SIZE / SRAM_BLOCK_SIZE)
// Position of ramdisk.
#define RAMDISK_SRAM_BASE		(KERNEL_SRAM_BASE + KERNEL_MAX_SIZE)
#define RAMDISK_DRAM_BASE		(0xC0500000)
#define RAMDISK_MAX_SIZE		(0x00320000)

// Position of ucos.
#define UCOS_SRAM_BASE			(0x00000000)
#define UCOS_DRAM_BASE			(0xC0000000)
#define UCOS_MAX_SIZE			(LOADER_DRAM_MAX_SIZE)
//#define UCOS_MAX_SIZE			(DRAM_BASE_ADDR+DRAM_SIZE - LOADER_DRAM_MAX_SIZE)

#define NUM_RAMDISK_BLOCKS		(RAMDISK_MAX_LEN / SRAM_BLOCK_SIZE)


///// Newwork /////////////////////////////////////////////////////////////////
#define CLIENT_ETHER			{0x00, 0xD0, 0xCA, 0xF1, 0x26, 0x21}
#define MAX_PKT_SIZE			608

// Autoboot  ٸ ð.
#define DELAY_BEFORE_BOOT		3


// .
#define USE_LCD_LOGO

#endif		// end _CONFIG_H_4718034674012374874802.
